Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaderenv.h
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaderenv.h	(revision 3089)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaderenv.h	(revision 3092)
@@ -42,6 +42,6 @@
 #define MAX_LOD_LEVEL 10
 
-#define MIN_DEPTH_DIFF 1e-2f
-#define PRECISION_SCALE 1e-2f
+#define MIN_DEPTH_DIFF 1e-3f
+#define PRECISION_SCALE 1e-1f
 
 // burnout
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/deferred.cg
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/deferred.cg	(revision 3089)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/deferred.cg	(revision 3092)
@@ -145,5 +145,5 @@
 				  uniform float4x4 shadowMatrix,
 				  uniform float sampleWidth,
-				  uniform sampler2D noise,
+				  uniform sampler2D noiseTex,
 				  uniform float2 samples[NUM_PCF_TABS],
 				  uniform float weights[NUM_PCF_TABS],
@@ -189,6 +189,6 @@
 		lightSpacePos /= lightSpacePos.w;
 
-		float shadowTerm = CalcShadowTerm(IN, shadowMap, sampleWidth, lightSpacePos.xy, lightSpacePos.z, samples, weights, noise);
-		//float shadowTerm = CalcShadowTerm(IN, shadowMap, sampleWidth, lightSpacePos.xy, lightSpacePos.z, samples, noise);
+		float shadowTerm = CalcShadowTerm(IN, shadowMap, sampleWidth, lightSpacePos.xy, lightSpacePos.z, samples, weights, noiseTex);
+		//float shadowTerm = CalcShadowTerm(IN, shadowMap, sampleWidth, lightSpacePos.xy, lightSpacePos.z, samples, noiseTex);
 
 		diffuse *= shadowTerm;
@@ -235,5 +235,6 @@
 	const float currentDepth = currentPos.z * precisionScale;
 
-	const float2 ao = ssao(IN, colors, noise, samples, normal, eyeSpacePos, w, bl, br, tl, tr, normalize(viewDir));
+	const float2 ao = ssao(IN, colors, noise, samples, normal, 
+		                   eyeSpacePos, w, bl, br, tl, tr, normalize(viewDir));
 
 
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/mrt.cg
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/mrt.cg	(revision 3089)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/mrt.cg	(revision 3092)
@@ -42,5 +42,5 @@
 
 
-//#pragma position_invariant vtx
+#pragma position_invariant vtx
 
 vtxout vtx(vtxin IN)
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/antialiasing.cg
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/antialiasing.cg	(revision 3026)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/antialiasing.cg	(revision 3092)
@@ -26,5 +26,5 @@
 			): COLOR
 {
-	//return tex2D(colors, IN.c.xy);
+	return tex2D(colors, IN.c.xy);
 
 	// normal discontinuity filter
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/ssao.cg
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/ssao.cg	(revision 3091)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/ssao.cg	(revision 3092)
@@ -60,6 +60,4 @@
 	return samplePos;
 }
-
-#pragma position_invariant temporalSmoothing
 
 
@@ -137,7 +135,7 @@
 						 uniform float3 oldbr,
 						 uniform float3 oldtl,
-						 uniform float3 oldtr,
-						 const uniform float4x4 inverseModelTrafo,
-						 float id
+						 uniform float3 oldtr
+						 //,const uniform float4x4 inverseModelTrafo
+						 //, float id
 						 )
 {
@@ -147,11 +145,8 @@
 	//-- compute reprojection for temporal smoothing
 
-	float4x4 trafo;
-
+	//float4x4 trafo;
 	// dynamic object
-	if (id > 20)
-		trafo = oldModelViewProj;
-	else
-		trafo = inverseModelTrafo * oldModelViewProj;
+	//if (id > 20) trafo = oldModelViewProj;
+	//else trafo = inverseModelTrafo * oldModelViewProj;
 
 	// reproject into old frame and calculate projected depth
@@ -174,5 +169,8 @@
 
 	const float depthDif = length(oldSamplePos - worldPos.xyz);
-	
+	//const float dummy5 = abs(oldEyeSpaceDepth - eyeSpaceDepth);
+	const float dummy5 = length(oldTexCoords - texcoord0) * 1e5f;
+	//const float dummy5 = depthDif;
+
 	float notValid = 0.5f;
 
@@ -225,5 +223,6 @@
 	illum_col.y = newWeight;
 	illum_col.w = eyeSpaceDepth;
-	
+	illum_col.y = dummy5;
+
 	return illum_col;
 }
@@ -394,10 +393,10 @@
 
 	float4 col = tex2Dlod(colors, float4(IN.texCoord, 0, 0));
-	float3 ao = tex2Dlod(ssaoTex, float4(IN.texCoord, 0, 0));
-
-	if (ao.y < 10.0f) ao.x = Filter(IN.texCoord, ssaoTex, filterOffs, filterWeights);
-
-	OUT.illum_col = col * ao.x;
-	//OUT.illum_col = float4(ao.x, ao.x, ao.x, col.w);
+	float4 ao = tex2Dlod(ssaoTex, float4(IN.texCoord, 0, 0));
+
+	//if (ao.y < 10.0f) ao.x = Filter(IN.texCoord, ssaoTex, filterOffs, filterWeights);
+
+	//OUT.illum_col = col * ao.x;
+	OUT.illum_col = float4(ao.y, ao.y, ao.y, col.w);
 	//OUT.illum_col.xyz = float3(1.0f - ao.x, 1.0f - ao.y * 1e-2f, 1);
 	//OUT.illum_col.xyz = float3(1.0f - ao.x, ao.y, 0);
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/DeferredRenderer.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/DeferredRenderer.cpp	(revision 3090)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/DeferredRenderer.cpp	(revision 3092)
@@ -269,5 +269,6 @@
 	//-- the flip-flop fbos
 
-	mIllumFbo = new FrameBufferObject(w / 2, h / 2, FrameBufferObject::DEPTH_NONE);
+//	mIllumFbo = new FrameBufferObject(w / 2, h / 2, FrameBufferObject::DEPTH_NONE);
+	mIllumFbo = new FrameBufferObject(w, h, FrameBufferObject::DEPTH_NONE);
 	mFBOs.push_back(mIllumFbo);
 
@@ -278,5 +279,6 @@
 	}
 
-	mDownSampleFbo = new FrameBufferObject(w / 2, h / 2, FrameBufferObject::DEPTH_NONE);
+	//mDownSampleFbo = new FrameBufferObject(w / 2, h / 2, FrameBufferObject::DEPTH_NONE);
+	mDownSampleFbo = new FrameBufferObject(w, h, FrameBufferObject::DEPTH_NONE);
 	mDownSampleFbo->AddColorBuffer(ColorBufferObject::RGBA_FLOAT_32, ColorBufferObject::WRAP_CLAMP_TO_EDGE, ColorBufferObject::FILTER_LINEAR);
 	// downsample buffer for the normal texture